<?php
// Create the Manage Events and the Options submenus  
function my_em_create_events_submenu () {
	if( is_super_admin() ){
		add_submenu_page('events-manager', __('Reset Permalinks'),__('Reset Permalinks'),'activate_plugins','rewrite-perms','my_em_perm_form');
	}
}
add_action('admin_menu','my_em_create_events_submenu',100);

function my_em_perm_form(){
	global $wpdb;
	if( is_super_admin() && wp_verify_nonce($_REQUEST['_wpnonce'],'rewrite_perms') ){
		//create permalinks for each location, category, event
		$array = array('event' => EM_EVENTS_TABLE, 'location' => EM_LOCATIONS_TABLE, 'category' => EM_CATEGORIES_TABLE);
		foreach( $array as $prefix => $table ){
			$used_slugs = array();
			$results = $wpdb->get_results("SELECT {$prefix}_id AS id, {$prefix}_slug AS slug, {$prefix}_name AS name FROM $table", ARRAY_A);
			foreach($results as $row){
				$slug = sanitize_title($row['name']);
				$count = 2;
				while( in_array($slug, $used_slugs) ){
					$slug = preg_replace('/\-[0-9]+$/', '', $slug).'-'.$count;
					$count++;
				}
				$wpdb->query("UPDATE $table SET {$prefix}_slug='$slug' WHERE {$prefix}_id={$row['id']}");
				$used_slugs[] = $slug;
			}
		}	
		echo "<div class='updated'><p>Your events, locations and categories have had their permalinks reset to default values.</p></div>";	
	}
	?>
	<div class='wrap'>
		<div class="icon32" id="icon-plugins"><br></div>
		<h2>Rewrite Permalinks</h2>
		<div id="em-booking">
			<form action="" method="post">
				<input type="hidden" name="_wpnonce" value="<?php echo wp_create_nonce('rewrite_perms'); ?>" />
				Use this to reset Event Manager permalinks (totally independent from the rest of WP), in the event of a bad install or just reverting to default. You will not lose any information, but your links to events etc. will change if you had made customizations.
				<p class="submit"><input type="submit" value="Reset EM Permalinks" /></p>
			</form>
		</div>
	</div>
	<?php
}